Epic # 55575 (Accepted): Streamline JavaScript Code in the TYPO3 Backend
TYPO3 Version: 4.7
PHP Version: 5.3
Complexity:
Is Regression: No
Sprint Focus:
Subject: Load order of js files differs
Description

There is a difference of ordering for js files, in case they are compressed / concatenated or not.
Looks like pagerenderer inverses the "forceOnTop files" while the ResourceCompressor doesn't.

if ($properties['forceOnTop']) {
    if ($properties['section'] === self::PART_HEADER) {
        $jsFiles = $tag . LF . $jsFiles;
    } else {
        $jsFooterFiles = $tag . LF . $jsFooterFiles;
    }
} else {
    if ($properties['section'] === self::PART_HEADER) {
        $jsFiles .= LF . $tag;
    } else {
        $jsFooterFiles .= LF . $tag;
    }
}

Instead of prepanding the file we should use the same logic as in ResourceCompressor. We should build arrays for each kind of
section and merge them at the end.

The change of order should be communicated on launch. That's a breaking change for JS developers. They have to check the order
of there JS files.

Related issues:
duplicates Core - Bug # 53116: concatenateJs in conjunction with forceOnTop Resolved 2013-10-25

History
#1 - 2014-02-24 12:43 - Daniel Siepmann

Getting deeper, it looks like pagerenderer is right and Compressor should take care of forceOnTop. Currently this setting is just ignored.

#2 - 2014-02-24 16:00 - Markus Klein

Wait a bit, there's already a patch of mine pending I guess.
#3 - 2014-02-24 16:04 - Markus Klein
- Target version deleted (6.2.0)

Duplicate of #53116.

Merged in 6.1 and 6.2.

We've to ask the release managers whether backports to < 6.1 are allowed.

But wait a bit, if you intend to use this on any other version, as a patch for #56242 is pending.

#4 - 2014-03-10 16:37 - Daniel Siepmann
- Parent task set to #55575

#5 - 2015-01-30 10:05 - Benjamin Mack
- Status changed from New to Closed
